"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var selection = document.getSelection();

var _default = _react["default"].forwardRef(function CodeEditor(_ref, ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      style = _ref.style,
      highlight = _ref.highlight,
      props = _objectWithoutProperties(_ref, ["value", "onChange", "style", "highlight"]);

  var pos = _react["default"].useRef(0);

  ref = ref || _react["default"].useRef();

  props.onInput = function (e) {
    var code = e.target.textContent;
    if (!selection.anchorNode) return 0;
    var range = new Range();
    range.setStart(ref.current, 0);
    range.setEnd(selection.anchorNode, selection.anchorOffset);
    pos.current = range.toString().length;
    if (onChange) onChange(code);
  };

  props.onKeyDown = function (e) {
    var ch = e.key;

    if (ch == 'Tab' || ch == 'Enter') {
      e.preventDefault();
      if (ch == 'Tab') ch = '\t';
      if (ch == 'Enter') ch = '\n';
      var range = selection.getRangeAt(0);
      range.deleteContents();
      range.insertNode(new Text(ch));
      range.collapse();
    }
  };

  _react["default"].useEffect(function () {
    var p = pos.current;
    var child = ref.current.firstChild;

    while (p > 0) {
      var length = child.textContent.length;

      if (p > length) {
        p -= length;
        child = child.nextSibling;
      } else {
        if (child.nodeType == 3) return selection.collapse(child, p);
        child = child.firstChild;
      }
    }
  }, [value]);

  return _react["default"].createElement("code", _extends({}, props, {
    ref: ref,
    contentEditable: true,
    spellCheck: "false",
    dangerouslySetInnerHTML: {
      __html: highlight(value)
    }
  }));
});

exports["default"] = _default;